function varargout = bmsGUI(varargin)
% GUI Wrapper for the BMA function 'bms'
%
% Asks for selecting a base workspace variable containing the data, 
%    and subsequently the respective options for the function 'bms'.
% Then it enacts a call to 'bms'; the output is stored in workspace 
%    variables 'bmstemp' as well as 'ans'.
%
%INPUTS:
% A single Optional Input: String of a dataset variable in the workspace
%
%CAUTION: This GUI was created in a quick-and-dirty manner
%       for demonstration purposes
%      For proper Bayesian Modoel Averaging use the function 'bms'
%
%EXAMPLE
% load datafls
% bmsGUI;
%
%________________________________________________
%
% Equivalent function in R: none
% Author: Stefan Zeugner 2010 
% Url: http://bms.zeugner.eu


% BMSGUI M-file for bmsGUI.fig
%      BMSGUI, by itself, creates a new BMSGUI or raises the existing
%      singleton*.
%
%      H = BMSGUI returns the handle to a new BMSGUI or the handle to
%      the existing singleton*.
%
%      BMSGUI('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in BMSGUI.M with the given input arguments.
%
%      BMSGUI('Property','Value',...) creates a new BMSGUI or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before bmsGUI_OpeningFunction gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to bmsGUI_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help bmsGUI

% Last Modified by GUIDE v2.5 05-Aug-2010 13:39:10

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @bmsGUI_OpeningFcn, ...
                   'gui_OutputFcn',  @bmsGUI_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin & isstr(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before bmsGUI is made visible.
function bmsGUI_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to bmsGUI (see VARARGIN)

% Choose default command line output for bmsGUI
handles.output = hObject;

% Update handles structure
 guidata(hObject, handles);

% UIWAIT makes bmsGUI wait for user response (see UIRESUME)
% uiwait(handles.figure1);

	% CUSTOM CODE:
	
	temps=struct; temps.data=NaN; temps.K=NaN; temps.N=NaN;
	temps.editg=NaN; temps.editm =NaN;
	handles.settings = temps;
	handles.mcmc_is_enum=true;
	guidata(hObject, handles);
	%uiwait(handles.figure1);
	havedata = update_WSdata(handles,varargin);
	setDefaults(handles);
	RestEnabler(handles,false);
	if havedata
        try
         popup_data_Callback(handles.popup_data, eventdata, handles);
        catch
            error('asdffs');
        end;
	end
	% if havedata
	%     RestEnabler(handles,true);
	% else
	%     RestEnabler(handles,false);
	% end



% --- Outputs from this function are returned to the command line.
function varargout = bmsGUI_OutputFcn(hObject, eventdata, handles)
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;



% --- Executes during object creation, after setting all properties.
function popup_gtype_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popup_gtype (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end


% --- Executes on selection change in popup_gtype.
function popup_gtype_Callback(hObject, eventdata, handles)
% hObject    handle to popup_gtype (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns popup_gtype contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popup_gtype
oStr= get(hObject,'String'); oVal= get(hObject,'Value'); sStrVal=oStr{oVal};
if oVal==3
    set(handles.popup_gvalue,'Enable','on');
    set(handles.popup_gvalue,'String',{'hyper-UIP','hyper-BRIC','Custom Prior'},'Value',1);
elseif oVal==2
    set(handles.popup_gvalue,'Enable','off');
    set(handles.popup_gvalue,'String',{'EBL'},'Value',1);
elseif oVal==1
    set(handles.popup_gvalue,'Enable','on');
    set(handles.popup_gvalue,'String',{'UIP (g=N)', 'BRIC (max(N,K^2))', 'RIC (g=K^2)', 'Hannan-Quinn (g=log(N^3) )', 'Custom Value'},'Value',1);
end
setEditDefaults(handles,true,false);


% --- Executes during object creation, after setting all properties.
function popup_gvalue_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popup_gvalue (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end


% --- Executes on selection change in popup_gvalue.
function popup_gvalue_Callback(hObject, eventdata, handles)
% hObject    handle to popup_gvalue (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns popup_gvalue contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popup_gvalue
oStr= get(hObject,'String'); oVal= get(hObject,'Value'); sStrVal=oStr{oVal};
setEditDefaults(handles,true,false);


% --- Executes during object creation, after setting all properties.
function edit_gcustom_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_gcustom (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end



function edit_gcustom_Callback(hObject, eventdata, handles)
% hObject    handle to edit_gcustom (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA);
% Hints: get(hObject,'String') returns contents of edit_gcustom as text
%        str2double(get(hObject,'String')) returns contents of edit_gcustom as a double
  myval=str2num(get(hObject,'String'));
  isproblem=false;
  
  if ~isempty(myval)
  oStr=get(handles.popup_gvalue,'String'); oVal=get(handles.popup_gvalue,'Value'); oSel=oStr{oVal};
  
  switch lower(oSel)
      case 'custom prior'
          errmsg='hyper-g prior parameter must be >2 and <=4 !';
          if ~isreal(myval);  isproblem=true; end;  
          if myval<=2 || myval>4;  isproblem=true; end;  
      case 'custom value'
          errmsg='g prior value must be a positive real!';
          if ~isreal(myval);  isproblem=true; end;  
          if myval<=0;  isproblem=true; end;  
  end
  
  elseif ~isempty(get(hObject,'String'))
         errmsg = 'g prior value must be a positive scalar!'
         isproblem=true;
  end   
  
  
     if isproblem
         msgbox(errmsg);
         set(hObject,'String','')
     end

   handles.settings.editg = str2num(get(hObject,'String'));
   guidata(hObject,handles);
   

% --- Executes during object creation, after setting all properties.
function popup_mprior_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popup_mprior (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end


% --- Executes on selection change in popup_mprior.
function popup_mprior_Callback(hObject, eventdata, handles)
% hObject    handle to popup_mprior (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns popup_mprior contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popup_mprior

setEditDefaults(handles,false,true);


% --- Executes during object creation, after setting all properties.
function edit_mprior_size_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_mprior_size (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end



function edit_mprior_size_Callback(hObject, eventdata, handles)
% hObject    handle to edit_mprior_size (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_mprior_size as text
%        str2double(get(hObject,'String')) returns contents of edit_mprior_size as a double

  myval=str2num(get(hObject,'String'));
  isproblem=false;
  myK=handles.settings.K;
  errmsg=['Prior model size must be a real scalar between 0 and ' num2str(myK)];
  if ~isempty(myval)
          if ~isreal(myval);  isproblem=true; end;  
          if ~isnan(myK)
              if myval<0 || myval>myK;  
                  isproblem=true; 
              end
          end
           
  elseif ~isempty(get(hObject,'String'))
         isproblem=true;
  end   
  
  
     if isproblem
         msgbox(errmsg);
         set(hObject,'String',num2str(myK/2))
     end






% --- Executes during object creation, after setting all properties.
function popup_mcmc_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popup_mcmc (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end


% --- Executes on selection change in popup_mcmc.
function popup_mcmc_Callback(hObject, eventdata, handles)
% hObject    handle to popup_mcmc (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns popup_mcmc contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popup_mcmc
oStr= get(hObject,'String'); oVal= get(hObject,'Value'); sStrVal=oStr{oVal};
myK = handles.settings.K;
  if oVal==3
        set(handles.edit_burn,'Enable','off');
        set(handles.edit_iter,'Enable','off');
        set(handles.edit_burn,'String',0); 
        
        if isnan(myK)
        set(handles.edit_iter,'String', 'NA');
        else
        set(handles.edit_iter,'String', myK^2);
        end;
        handles.mcmc_is_enum = true; 

  else
        set(handles.edit_burn,'Enable','on');
        set(handles.edit_iter,'Enable','on');
        if handles.mcmc_is_enum 
            set(handles.edit_burn,'String',1000);
            set(handles.edit_iter,'String',3000);
        end;
        handles.mcmc_is_enum = false; 
  end
guidata(hObject, handles);
  
% --- Executes during object creation, after setting all properties.
function edit_burn_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_burn (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end




function edit_burn_Callback(hObject, eventdata, handles)
% hObject    handle to edit_burn (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_burn as text
%        str2double(get(hObject,'String')) returns contents of edit_burn as a double


% --- Executes during object creation, after setting all properties.
function edit_iter_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_iter (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end



function edit_iter_Callback(hObject, eventdata, handles)
% hObject    handle to edit_iter (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_iter as text
%        str2double(get(hObject,'String')) returns contents of edit_iter as a double




% --- Executes during object creation, after setting all properties.
function edit_nmodel_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_nmodel (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end



function edit_nmodel_Callback(hObject, eventdata, handles)
% hObject    handle to edit_nmodel (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_nmodel as text
%        str2double(get(hObject,'String')) returns contents of edit_nmodel as a double


% --- Executes on button press in check_logfile.
function check_logfile_Callback(hObject, eventdata, handles)
% hObject    handle to check_logfile (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of check_logfile


% --- Executes on button press in check_user_int.
function check_user_int_Callback(hObject, eventdata, handles)
% hObject    handle to check_user_int (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --- Executes during object creation, after setting all properties.
function popup_data_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popup_data (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end


% --- Executes on selection change in popup_data.
function popup_data_Callback(hObject, eventdata, handles)
% hObject    handle to popup_data (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns popup_data contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popup_data
oStr= cellstr(get(hObject,'String')); oVal= get(hObject,'Value'); sStrVal=oStr{oVal};
if ~isempty(sStrVal)
   [mydata, myK, myN] = getDataInfo(sStrVal);

if myK<0; msgbox(mydata); 
    set(handles.popup_data,'Value',1);
    RestEnabler(handles,false);
    return; 
end
set(handles.popup_data,'Enable','off');
handles.settings.data = mydata; handles.settings.K = myK; handles.settings.N = myN;
guidata(hObject, handles);
RestEnabler(handles,true);
setDefaults(handles);
end;


function [ already_supplied ] = update_WSdata(handles,varinputs)
    
       %check if a data varaible was provided
       % if not, display a selection of all eligible work space variables
      if nargin>1;
       if ~isempty(varinputs) 
        if ischar(varinputs{1})   
            popupstring = varinputs{1}; popupstring=popupstring(1,:);
           if evalin('base',['exist(''' popupstring ''')']);
            set(handles.popup_data,'String',popupstring);
            %set(handles.popup_data,'Enable','off');
            already_supplied =true;
            return;
           end
         end;
       end;
      end;

    already_supplied = false;  
    vars = evalin('base','whos');
    eligibles={''};
    
    
    %stupid slow way to extract info due to Matlab 6
    for ix=1:length(vars)
        addit=false;
        if strcmpi(vars(ix).class,'double'); 
            if evalin('base',['ndims(' vars(ix).name ')==2']) && evalin('base',['size(' vars(ix).name ',2)>1']);
                addit=true; 
            end;
        elseif strcmpi(vars(ix).class,'struct'); 
            if evalin('base',['isfield(' vars(ix).name ',''data'')']);
                if evalin('base',['isreal(' vars(ix).name '.data)']);
                    addit=true;
                end
            end
        elseif strcmpi(vars(ix).class,'dataset'); 
            addit=true;
        end
     
        if addit 
            eligibles{length(eligibles)+1} = vars(ix).name;
        end
    end

    if isempty(vars)
        popupstring = 'Select Data from Workspace';
    else
        popupstring = eligibles;
    end;
    
    
    set(handles.popup_data,'String',popupstring);
    set(handles.popup_data,'Enable','on');


% --- Executes on button press in pushbutton_run.
function pushbutton_run_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_run (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
X_data=handles.settings.data;
burn =  str2num(get(handles.edit_burn,'String'));
iter =  str2num(get(handles.edit_iter,'String'));
nmodel =  str2num(get(handles.edit_nmodel,'String'));
mprior_size =  str2num(get(handles.edit_mprior_size,'String'));
user_int =  get(handles.check_user_int,'Value');
logfile =  get(handles.check_logfile,'Value');
switch get(handles.popup_mcmc,'Value');
    case 3
        mcmc='enumerate';
    case 2
        mcmc='rev.jump';
    otherwise
        mcmc='bd';
end
switch get(handles.popup_mprior,'Value');
    case 3
        mprior='uniform';
    case 2
        mprior='fixed';
    otherwise
        mprior='random';
end;

lgtype=get(handles.popup_gtype,'Value');
 if lgtype==3;
     switch get(handles.popup_gvalue,'Value');
         case 3
            g=['hyper=' get(handles.edit_gcustom,'String') ];
         case 2
             g='hyper=BRIC';
         otherwise    
             g='hyper=UIP';
     end
     
 elseif lgtype==2;
     g='EBL';
 else
     switch get(handles.popup_gvalue,'Value');
         case 5
            g=str2num(get(handles.edit_gcustom,'String'));
         case 4
             g='HQ';
         case 3    
             g='RIC';
         case 2
             g='BRIC';
         otherwise
             g='UIP';
     end
   end

dataname=cellstr(get(handles.popup_data,'String')); dataval=get(handles.popup_data,'Value'); dataname=dataname{dataval};
   
   
if isempty(burn); msgbox('Burn-ins needs to be an integer>=0'); return; end;
if isempty(iter); msgbox('Counted Iterations needs to be an integer>=0'); return; end;
if isempty(nmodel); msgbox('No. of best models needs to be an integer >=0'); return; end;

try
	[X_struct, burn, iter, nmodel, mcmc, g, mprior, mprior_size, user_int, logfile] = bms_checkargs(X_data, burn, iter, nmodel, mcmc, g, mprior, mprior_size, user_int, logfile);    
catch
    theproblem=lasterror;
    msgbox(theproblem.message)
    return;
end;
    
    RestEnabler(handles,false);
	if ischar(g); strg=['''' g '''']; else strg=num2str(g); end;
	struserlog='';
	if user_int & logfile; struserlog=', true, true'; end;
	if ~user_int & ~logfile; struserlog=', false'; end;
	if ~user_int & logfile; struserlog=', false, true'; end;
	bmscmd=['bms(' dataname ', ' num2str(burn) ', ' num2str(iter) ', ' num2str(nmodel) ', ''' mcmc ''', ' strg ', ''' mprior ''', ' num2str(mprior_size)  struserlog ');'];
    
	disp(bmscmd);    
    disp(['bms is sampling ' num2str(burn+iter) ' model draws. Please wait...']);    
    delete(handles.figure1);
    evalin('base',['bmstemp = ' bmscmd]);
    evalin('base','ans=bmstemp;');



function [datavar, myK, myN] = getDataInfo(mydata)

   if ischar(mydata)
       mydata = evalin('base',mydata);
   end
   try; mydata2=bms_checkargs(mydata,NaN,NaN,NaN,NaN,NaN,NaN,NaN,NaN,NaN); end;
   if exist('mydata2');
       datavar =mydata2;
       myK =size(mydata2.data,2)-1;
       myN =size(mydata2.data,1);
   else
       datavar=lasterr;
       myK=-1; myN=-1;
   end
   
   
function RestEnabler(handles,enable)
    
    if enable; enab_char='on'; else enab_char='off'; end;
    set(handles.pushbutton_run,'Enable',enab_char);
    set(handles.popup_gtype,'Enable',enab_char);
    set(handles.popup_gvalue,'Enable',enab_char);
    set(handles.edit_gcustom,'Enable',enab_char);
    set(handles.text_popup_gtype,'Enable',enab_char);
    set(handles.text_popup_gvalue,'Enable',enab_char);
    set(handles.text_edit_gcustom,'Enable',enab_char);
    
    set(handles.popup_mprior,'Enable',enab_char);
    set(handles.edit_mprior_size,'Enable',enab_char);
    set(handles.text_popup_mprior,'Enable',enab_char);
    set(handles.text_edit_mprior_size,'Enable',enab_char);
    
    
    set(handles.popup_mcmc,'Enable',enab_char);
    set(handles.edit_burn,'Enable',enab_char);
    set(handles.edit_iter,'Enable',enab_char);
    set(handles.text_popup_mcmc,'Enable',enab_char);
    set(handles.text_edit_burn,'Enable',enab_char);
    set(handles.text_edit_iter,'Enable',enab_char);
    
    set(handles.edit_nmodel,'Enable',enab_char);
    set(handles.text_edit_nmodel,'Enable',enab_char);
    set(handles.check_user_int,'Enable',enab_char);
    set(handles.check_logfile,'Enable',enab_char);
    
    
function setEditDefaults(handles,dog,domprior)
if nargin<2; dog=true; domprior=true; end;
	myK = handles.settings.K;
	myN = handles.settings.N;
	if isnan(myK) | isnan(myN)
        if dog
            set(handles.edit_gcustom,'String','NA');
            set(handles.edit_gcustom,'Enable','off');
        end
        if domprior
            set(handles.edit_mprior_size,'String','NA');   
            set(handles.edit_mprior_size,'Enable','off');
        end
        
        return;
	end
	
	%doing stuff for edit_mprior_size
    if domprior
	set(handles.edit_mprior_size, 'String', myK/2);
	hObject = handles.popup_mprior;
	oStr= get(hObject,'String'); oVal= get(hObject,'Value'); sStrVal=oStr{oVal};
	if strcmpi(sStrVal,'Uniform'); myen='off'; else myen='on'; end;
	set(handles.edit_mprior_size,'Enable', myen);
    end;

    if dog
    hObject = handles.popup_gvalue;
    oStr= get(hObject,'String'); oVal= get(hObject,'Value'); sStrVal=oStr{oVal};
	%doing stuff for edit_gcustom
	if strcmpi(sStrVal,'Custom Value')
        set(handles.edit_gcustom,'Enable','on');
	elseif strcmpi(sStrVal,'Custom Prior')
        set(handles.edit_gcustom,'Enable','on');   
	else
        set(handles.edit_gcustom,'Enable','off');
	end
    
    myg='NA';
    lgtype=get(handles.popup_gtype,'Value');
    if lgtype==1; 
        if oVal==1; 
            myg=myN; 
        elseif oVal==2;
            myg=max(myN,myK^2); 
        elseif oVal==3;
            myg=myK^2;
        elseif oVal==4;
            myg=log(myN)^3;
        else
            myg=myN; 
        end;
    elseif lgtype==3;
        if oVal==1; 
            myg=2+2/myN;
        elseif oVal==2;
            myg=2+2/max(myN,myK^2);
        else
            myg=2+2/myN;
        end;
        
    end;
    set(handles.edit_gcustom,'String', myg);
    end;

    
function setSamplerDefaults(handles)
    myK = handles.settings.K;
	if isnan(myK) | myK > 14
        set(handles.popup_mcmc,'Value',1);
    else
        set(handles.popup_mcmc,'Value',3);
	end
    popup_mcmc_Callback(handles.popup_mcmc, NaN, handles)
    
    
    
    
    
function setDefaults(handles)
    set(handles.popup_mprior,'Value',1);
    set(handles.popup_gtype,'Value',1);
    set(handles.edit_nmodel,'String',500);
    set(handles.check_user_int,'Value',1);
    set(handles.check_logfile,'Value',0);
    popup_gtype_Callback(handles.popup_gtype, NaN, handles);
    setEditDefaults(handles,true,true);
    setSamplerDefaults(handles);
    
    
   


% --- Executes on button press in pushbutton_cancel.
function pushbutton_cancel_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_cancel (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
delete(handles.figure1);


% --- Executes when user attempts to close figure1.
function figure1_CloseRequestFcn(hObject, eventdata, handles)
% hObject    handle to figure1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: delete(hObject) closes the figure
delete(hObject);


% --- Executes during object creation, after setting all properties.
function figure1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to figure1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called


