function loadRworkspace(filepath)
% loads the variables in the R session used for BMS
%
%loadRworkspace(filepath)
%
%NOTES:
% If you want to load a workspace with bma objects, you should load
% the corresponding R objects as well - otherwise you might not be able to
% use them
%
%EXAMPLE: 
% libraryBMS % open BMS
% load datafls
% mm=bms(datafls); %create a bma object
% saveRworkspace 'myBMA'; %save R stuff to an .RData file
% save 'myBMA'; %save Matlab stuff to a .mat file
% closeBMS
% clear; %clear everything
% 
% %now load the session again:
% libraryBMS;
% load 'myBMA';
% loadRworkspace 'myBMA';
% print_bma(mm);
%
%_________________________
%
%SEE ALSO
% closeBMS, bms, libraryBMS, saveRworkspace
%
%Equivalent function in R: load
%Author: Stefan Zeugner 2010 
%Url: http://bms.zeugner.eu   


   isBMSopen(false);
   
   if length(filepath)>6
   if not(strcmpi(filepath((end-5):end),'.RData'))
       filepath = [filepath '.RData'];
   end
   else
       filepath = [filepath '.RData'];
   end
   
   if not(exist(filepath,'file')>0)
       error(['specified file ' filepath ' does not exist']);
   end
   
      
   spwdpath=pwd;
   spwdpath=strrep(spwdpath,'\','/');
   evalinR(['oldpath=getwd(); setwd(''' spwdpath ''')']);
   evalinR(['load(''' filepath ''');']);
   evalinR(['setwd(oldpath); rm(oldpath);']);
   