function [data, msg] = getRdata(varname)
% Get the variable 'varname' from the open R session.
% this function was inspired by Robert Henson's Matlab R-link toolbox
% http://www.mathworks.com/matlabcentral/fileexchange/5051

global RBMS_LinkHandle

msg = '';
try
    data = RBMS_LinkHandle.GetSymbol(varname);
catch
    data = [];
    msg = lasterr;
    if nargout == 0
        error('Could not get %s.\n%s',varname,msg);
    end
end
