# functions for communication with MAtlab via statconn/DCOM

info.bma_matlab=function(...) {
    res=info.bma(...);
    res=cbind(names(res),res);
    return(res);
}

is.bma_matlab = function(obname) {
   if (!exists(obname)) return(FALSE);
   if (!is.bma(get(obname))) return(FALSE);
   return(TRUE);
}

modelsize_matlab = function(bmao,exact=FALSE) {
   priordist=bmao$mprior.info$mp.Kdist;

    K=bmao$info$K
    if (is.element("mprior.info",names(bmao))) m=bmao$mprior.info$mp.msize else m=bmao$arguments$prior.msize
    pmp.10=pmp.bma(bmao$topmod)

    if(exact){
      modelSmean=sum(apply(.post.topmod.bma(bmao$topmod),2,function(x) length(which(x==1)))*pmp.10[,1])
      modelS.var=sum(apply(.post.topmod.bma(bmao$topmod),2,function(x) length(which(x==1)))^2*pmp.10[,1])-modelSmean^2
      x = apply(.post.topmod.bma(bmao$topmod),2,function(x) length(which(x==1)))
      y = pmp.10[,1]
      result = c()
      for( i in sort(unique(x)) )
         result = c(result, sum(y[which(x==i)]))
      names(result) = sort(unique(x))
      kvec=rep(0,(K+1))
      kvec[(as.numeric(names(result))+1)]=result
    }
    else{
      k.vec=bmao$info$k.vec
     #calculate expected value
      summi=sum(k.vec)
     #modelSmean -1 because we have to deduct the constant from the mean model size
      kvec=k.vec/sum(k.vec)
    }

    return(cbind(priordist,kvec));


}

densitybma_single_matlab = function(bmao, reg=1, std.coefs=FALSE, n=300) {
    png('bmstemp.png');
    mydens = density(bmao,reg=reg,std.coefs=std.coefs,n=n, plot=FALSE) ;
    dev.off();
    if (all(mydens$y==0)) {
       return(matrix(0,1,2));
    } else {
       return(cbind(mydens$x,mydens$y));
    }

}