function print_bma(bmao)
%Printing bma Objects
%
%print_bma(bmao)
%
%% INPUTS:
%required inputs:
% * bmao: a 'bma' object (as e.g. resulting from bms)
%
%% OUTPUT:
%  Prints nicely formatted outputs of coef_bma and summary_bma to the
%  console; in addition it prints the command used within R
%
%% EXAMPLE:
% load datafls;
% mm=bms(datafls);
% print_bma(mm); %does the same printout again
%________________________________________________
%
%% SEE ALSO
% bms, coef_bma, summary_bma
% 
% Equivalent function in R: print.bma
% Author: Stefan Zeugner 2010 
% Url: http://bms.zeugner.eu


    lLeadBlanks=4;
    
    is_bma(false);
    
    disp(sprintf('\n %s BMA RESULT %s \n',repmat('_',1,10),repmat('_',1,20+lLeadBlanks)));
    disp(sprintf('%s R call: %s\n', repmat(' ',1,lLeadBlanks), bmao.Rcmd));
    disp(sprintf('%s Coefficients %s \n',repmat('_',1,10),repmat('_',1,20+lLeadBlanks)));
    coefcontainer=c2cstr(bmao.coef);
    coefcontainer = vertcat({'PIP','Post Mean','Post SD','Cond.Pos.Sign','Idx'},coefcontainer); 
    coefcontainer=horzcat(bmao.data.Properties.VarNames([0;bmao.coef(:,end)]+1),coefcontainer);
    coefcontainer{1,1}='Variable';
    disp(Cstr2format(coefcontainer,4,0,lLeadBlanks,[-1;1;1;1;1;1],0));

    disp(sprintf('%s Statistics %s \n',repmat('_',1,10),repmat('_',1,20+lLeadBlanks)));
    disp(Cstr2format(bmao.summary,6,0,5,[-1;1]))
    disp(sprintf('%s \n',repmat('_',1,40+lLeadBlanks)));